package NTLSystem.features;

import NTLSystem.NTLException;

/**
 * An exception used thrown by EditableDataElement implementers
 * stating that object is not currently being edited [when
 * saveValues() is called].
 * <P>
 * $Id: NotBeingEditedException.java,v 1.2 1998/10/16 01:57:13 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @author    Josh Sled [jsled@icsi.berkeley.edu]
 * @see       EditableDataElement
 * @version   $Revision: 1.2 $
 **/

public class NotBeingEditedException
extends NTLException
{
  /** A new NTLException without a message. **/
  public NotBeingEditedException() { super(); }
  /**
   * A new NTLException with a message.
   *
   * @param     m The message text.
   **/
  public NotBeingEditedException(String m) { super(m); }
}

