package NTLSystem.verblearn;

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import NTLSystem.support.*;

/**
 * The infamous SelectoMeter.  A neat little widget...
 * <P>
 * <EM>Note: This class need not be public, but it is to get Javadoc
 * to generate docs for it... this is a Javadoc 1.1 bug, fixed in
 * 1.2.</EM> 
 * <P>
 * $Id: SelectoMeter.java,v 1.4 1998/09/09 23:54:02 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @author    Joshua Sled [jsled@icsi.berkeley.edu]
 * @see       ScenarioViewer
 * @version   $Revision: 1.4 $
 **/
public class SelectoMeter
    extends JComponent
{

    private static Dimension size = new Dimension(200, 30);
  
    public int BARHEIGHT = 12;
    public int numberOfThings = 100;
    public int[] selectedIndices = {};
    public int currentIndex = 0;
    public int clickedIndex = 0;

    public SelectoMeter()
    {
	super();
    }
 
  public void setNumberOfThings(int i){
     numberOfThings = i;
  }

  public void setSelectedIndices(int[] i){
     selectedIndices = i;
  }

  public void setCurrentIndex(int i){
     currentIndex = i;
  }
  
  public void paint(Graphics g){
      int width = getSize().width;
      int height = getSize().height;
      g.setColor(Color.black);
      g.drawRect(1, 5, width-2, BARHEIGHT);
      g.setColor(Color.white);
      g.fillRect(2, 6, width-4, BARHEIGHT-1);
      g.setColor(Color.red);
      for (int i=0; i<selectedIndices.length; i++){
         int value = selectedIndices[i];
         if ((0<=value) && (value<numberOfThings)){
             int start = (width-4)*value / numberOfThings;
             int stop = (width-4)*(value+1) / numberOfThings;
             int thickness = stop-start+1;
             if (thickness <= 0) thickness = 1;
             g.fillRect(2+start, 6, thickness, BARHEIGHT-1);
         }
      }
      g.setColor(Color.black);
      if ((0<=currentIndex) && (currentIndex<numberOfThings)){
         int carat = (width-4)*currentIndex / numberOfThings + 3;
         int[] x = {carat, carat+4, carat-4};
         int[] y = {4+BARHEIGHT, 14+BARHEIGHT, 14+BARHEIGHT};
         g.fillPolygon(x, y, 3);
      }   
  }

  public boolean mouseDrag(Event e, int x, int y){
      int width = getSize().width;
      //int height = getSize().height;
      int index = (x * numberOfThings) / width;
      if (0<=index && index<numberOfThings) {
         clickedIndex = index;
      }
      return false;
  }

  public boolean mouseDown(Event e, int x, int y){
      int width = getSize().width;
      //int height = getSize().height;
      int index = (x * numberOfThings) / width;
      if (0<=index && index<numberOfThings) {
         clickedIndex = index;
      }
      return false;
  }

    public Dimension getMinimumSize()
    {
	return size;
    }

    public Dimension getPreferredSize()
    {
	return size;
    }
}
